
/**************
* OpenGraphics Expert Advisor
* Version 1.01: bodshyipmonitor@forex-tsd
 - Solve Date Expiration Problem.
*
* Version 1.02: bodshyipmonitor@forex-tsd
  - Add GMACD(CJA) Ver2.0 into buystop and sellstop conditions
  - Solve error130 problem 
  - Solve StopLoss Problem
  - Add TakeProfit Variable to overwrite takeprofit if higher
*
*/////////////////////////////////

#define MAGIC_NUMB 3512797

extern string s1="//====Position settings====//";
extern double Lots=0.1;
extern int TakeProfit=40;
extern int DefaultStopLoss=40;
extern int TrailingStop = 20;
extern string s2="//====OpenGraphics settings====//";
extern int BUY_Area =20;
extern int BUY_Target_1 =40;
extern int SELL_Area = 20;
extern int SELL_Target_1 =40;
int curr_day=-1;
bool bs=false,ss=false;

extern string s4="//====GMACD settings====//";
extern int FastEMA = 8;
extern int SlowEMA = 17;
extern int SignalSMA = 9;
bool Show_MAJOR_TREND = true;

color color_m1, color_m5, color_m15, color_m30, color_h1, color_h4, color_d1, color_w1, color_mn, color_signal, color_main, color_level;

void CloseAllPositions()
{
   string symbol=Symbol();
   for(int i=OrdersTotal()-1;i>=0;i--)
   {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)&&OrderSymbol()==symbol&&OrderMagicNumber()==MAGIC_NUMB)
      {
         if(OrderType()==OP_BUY)
         {
           if(!OrderClose(OrderTicket(),OrderLots(),Bid,3,Yellow))
               Print("Error close BUY order : ",GetLastError());
         }
         if(OrderType()==OP_SELL)
         {
            if(!OrderClose(OrderTicket(),OrderLots(),Ask,3,Red))
               Print("Error close SELL order : ",GetLastError());
         }
      }
   }
}
//Close all Pending Positions
void CloseAllPendingPositions()
{
   string symbol=Symbol();
   for(int i=OrdersTotal()-1;i>=0;i--)
   {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)&&OrderSymbol()==symbol&&OrderMagicNumber()==MAGIC_NUMB)
      {
         if(OrderType()==OP_BUYSTOP)
         {
           if(!OrderDelete(OrderTicket(),Yellow))
               Print("Error close BUYSTOP order : ",GetLastError());
         }
         if(OrderType()==OP_SELLSTOP)
         {
            if(!OrderDelete(OrderTicket(),Red))
               Print("Error close SELLSTOP order : ",GetLastError());
         }
      }
   }
}

//GMACD Codes By CJA
void GMACD(){
    int counted_bars = IndicatorCounted();
//----
    double macd_M1=iMACD(NULL,PERIOD_M1,FastEMA,SlowEMA,SignalSMA,PRICE_CLOSE,MODE_MAIN,0); 
    double macd_MM1=iMACD(NULL,PERIOD_M1,FastEMA,SlowEMA,SignalSMA,PRICE_CLOSE,MODE_SIGNAL,0); 
    double macd_M5=iMACD(NULL,PERIOD_M5,FastEMA,SlowEMA,SignalSMA,PRICE_CLOSE,MODE_MAIN,0); 
    double macd_MM5=iMACD(NULL,PERIOD_M5,FastEMA,SlowEMA,SignalSMA,PRICE_CLOSE,MODE_SIGNAL,0);
    double macd_M15=iMACD(NULL,PERIOD_M15,FastEMA,SlowEMA,SignalSMA,PRICE_CLOSE,MODE_MAIN,0); 
    double macd_MM15=iMACD(NULL,PERIOD_M15,FastEMA,SlowEMA,SignalSMA,PRICE_CLOSE,MODE_SIGNAL,0);
    double macd_M30=iMACD(NULL,PERIOD_M30,FastEMA,SlowEMA,SignalSMA,PRICE_CLOSE,MODE_MAIN,0); 
    double macd_MM30=iMACD(NULL,PERIOD_M30,FastEMA,SlowEMA,SignalSMA,PRICE_CLOSE,MODE_SIGNAL,0); 
    double macd_H1=iMACD(NULL,PERIOD_H1,FastEMA,SlowEMA,SignalSMA,PRICE_CLOSE,MODE_MAIN,0); 
    double macd_HH1=iMACD(NULL,PERIOD_H1,FastEMA,SlowEMA,SignalSMA,PRICE_CLOSE,MODE_SIGNAL,0);
    double macd_H4=iMACD(NULL,PERIOD_H4,FastEMA,SlowEMA,SignalSMA,PRICE_CLOSE,MODE_MAIN,0); 
    double macd_HH4=iMACD(NULL,PERIOD_H4,FastEMA,SlowEMA,SignalSMA,PRICE_CLOSE,MODE_SIGNAL,0); 

    if (Show_MAJOR_TREND == true)
    {
    double macd_D1=iMACD(NULL,PERIOD_D1,FastEMA,SlowEMA,SignalSMA,PRICE_CLOSE,MODE_MAIN,0); 
    double macd_DD1=iMACD(NULL,PERIOD_D1,FastEMA,SlowEMA,SignalSMA,PRICE_CLOSE,MODE_SIGNAL,0); 
    double macd_W1=iMACD(NULL,PERIOD_W1,FastEMA,SlowEMA,SignalSMA,PRICE_CLOSE,MODE_MAIN,0); 
    double macd_WW1=iMACD(NULL,PERIOD_W1,FastEMA,SlowEMA,SignalSMA,PRICE_CLOSE,MODE_SIGNAL,0); 
    double macd_MN1=iMACD(NULL,PERIOD_MN1,FastEMA,SlowEMA,SignalSMA,PRICE_CLOSE,MODE_MAIN,0); 
    double macd_MMN1=iMACD(NULL,PERIOD_MN1,FastEMA,SlowEMA,SignalSMA,PRICE_CLOSE,MODE_SIGNAL,0); 
    }
        
    string  trend_signal = "", trend_main = "", trend_level = "";
          
    // UP Data
    if ((macd_M5 > macd_MM5) && (macd_M1 > macd_MM1)) { trend_signal = "TREND/UP"; color_signal = Lime;}
     //Down Data   
    if ((macd_M5 < macd_MM5) && (macd_M1 < macd_MM1)) { trend_signal = "TREND/DN"; color_signal = Red; }
    
    //Consolidation Data
    if ((macd_M5 < macd_MM5) && (macd_M1 > macd_MM1)) { trend_signal = "SIDEWAY"; color_signal = Orange; }
    if ((macd_M5 > macd_MM5) && (macd_M1 < macd_MM1)) { trend_signal = "SIDEWAY"; color_signal = Orange; }
    
    if ((macd_M15 < macd_MM15) && (macd_M30 > macd_MM30) && (macd_H1 > macd_HH1)&& (macd_H4 < macd_HH4)) { trend_level = "WEAK"; color_level = Tomato; }
    if ((macd_M15 > macd_MM15) && (macd_M30 < macd_MM30) && (macd_H1 < macd_HH1)&& (macd_H4 > macd_HH4)) { trend_level = "WEAK"; color_level = Tomato; }
     
    if ((macd_M15 < macd_MM15) && (macd_M30 > macd_MM30) && (macd_H1 < macd_HH1) && (macd_H4 < macd_HH4)) { trend_level = "MEDIUM"; color_level = Orange; }
    if ((macd_M15 > macd_MM15) && (macd_M30 < macd_MM30) && (macd_H1 > macd_HH1) && (macd_H4 > macd_HH4)) { trend_level = "MEDIUM"; color_level = Orange; }
    
    
    if ((macd_M5 > macd_MM5) && (macd_M15 > macd_MM15) && (macd_M30 > macd_MM30) && (macd_H1 < macd_HH1) && (macd_H4 > macd_HH4)) { trend_level = "MEDIUM"; color_level = Orange; }
    if ((macd_M5 < macd_MM5) && (macd_M15 < macd_MM15) && (macd_M30 < macd_MM30) && (macd_H1 >macd_HH1) && (macd_H4 < macd_HH4)) { trend_level = "MEDIUM"; color_level = Orange; }
    
    if ((macd_M15 < macd_MM15) && (macd_M30 > macd_MM30) && (macd_H1 > macd_HH1)) { trend_main = "TREND/UP"; color_main = YellowGreen; }
    if ((macd_M15 > macd_MM15) && (macd_M30 < macd_MM30) && (macd_H1 < macd_HH1)) { trend_main = "TREND/DN"; color_main = Tomato; }
    
    if ((macd_M15 < macd_MM15) && (macd_M30 < macd_MM30) && (macd_H1 > macd_HH1)) { trend_main = "TREND/DN"; color_main = Tomato; }
    if ((macd_M15 > macd_MM15) && (macd_M30 > macd_MM30) && (macd_H1 < macd_HH1)) { trend_main = "TREND/UP"; color_main = YellowGreen; }
    
    if ((macd_M15 < macd_MM15) && (macd_M30 > macd_MM30) && (macd_H1 < macd_HH1)) { trend_main = "TREND/DN"; color_main = Red; }
    if ((macd_M15 > macd_MM15) && (macd_M30 < macd_MM30) && (macd_H1 > macd_HH1)) { trend_main = "TREND/UP"; color_main = Lime; }
    
    if ((macd_M5 < macd_MM5) && (macd_M15 < macd_MM15) && (macd_H1 > macd_HH1) && (macd_H4 > macd_HH4)) { trend_level = "WEAK"; color_level = Tomato; }
    if ((macd_M5 > macd_MM5) && (macd_M15 > macd_MM15) && (macd_H1 < macd_HH1) && (macd_H4 < macd_HH4)) { trend_level = "WEAK"; color_level = Tomato; }
    
    if ((macd_M15 > macd_MM15) && (macd_H1 > macd_HH1) && (macd_M30 > macd_MM30) && (macd_H4 < macd_HH4)) { trend_level = "MEDIUM"; color_level = Orange; }
    if ((macd_M15 < macd_MM15) && (macd_H1 < macd_HH1) && (macd_M30 < macd_MM30) && (macd_H4 > macd_HH4)) { trend_level = "MEDIUM"; color_level = Orange; }
    
    if ((macd_M15 > macd_MM15) && (macd_H1 > macd_HH1) && (macd_M30 > macd_MM30) && (macd_H4 > macd_HH4)) { trend_level = "STRONG"; color_level = Yellow; }
    if ((macd_M15 < macd_MM15) && (macd_H1 < macd_HH1) && (macd_M30 < macd_MM30) && (macd_H4 < macd_HH4)) { trend_level = "STRONG"; color_level = Yellow; }
    
    if ((macd_M15 > macd_MM15) && (macd_H1 > macd_HH1) && (macd_M30 > macd_MM30) && (macd_H4 > macd_HH4)) { trend_main = "TREND/UP"; color_main = Lime; }
    if ((macd_M15 < macd_MM15) && (macd_H1 < macd_HH1) && (macd_M30 < macd_MM30) && (macd_H4 < macd_HH4)) { trend_main = "TREND/DN"; color_main = Red; }
    
     
    if ((macd_M15 > macd_MM15) && (macd_H1 > macd_HH1) && (macd_M30 > macd_MM30) && (macd_H4 < macd_HH4)) { trend_main = "TREND/UP"; color_main = Lime; }
    if ((macd_M15 < macd_MM15) && (macd_H1 < macd_HH1) && (macd_M30 < macd_MM30) && (macd_H4 > macd_HH4)) { trend_main = "TREND/DN"; color_main = Red; }              
    
    //MACD Direction
    if ((macd_M1 > macd_MM1)) { color_m1 = Lime; }
    if ((macd_M1 < macd_MM1)) { color_m1 = Red; }
    
    if ((macd_M5 > macd_MM5)) { color_m5 = Lime; }
    if ((macd_M5 < macd_MM5)) { color_m5 = Red; }
    
    if ((macd_M15 > macd_MM15)) { color_m15 = Lime;}
    if ((macd_M15 < macd_MM15)) { color_m15 = Red;}
    
    if ((macd_M30 > macd_MM30)) { color_m30 = Lime; }
    if ((macd_M30 < macd_MM30)) { color_m30 = Red; }
    
    if ((macd_H1 > macd_HH1)) { color_h1 = Lime; }
    if ((macd_H1 < macd_HH1)) { color_h1 = Red; }
    
    if ((macd_H4 > macd_HH4)) { color_h4 = Lime;}
    if ((macd_H4 < macd_HH4)) { color_h4 = Red; }

    if (Show_MAJOR_TREND == true)
    {    
      if ((macd_D1 > macd_DD1)) { color_d1 = Lime;}
      if ((macd_D1 < macd_DD1)) { color_d1 = Red;}
    
      if ((macd_W1 > macd_WW1)) { color_w1 = Lime; }
      if ((macd_W1 < macd_WW1)) { color_w1 = Red; }
    
      if ((macd_MN1 > macd_MMN1)) { color_mn = Lime; }
      if ((macd_MN1 < macd_MMN1)) { color_mn = Red; }
    }      

}


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   GMACD(); //Runing GMACD Analysis
  
   iCustom(Symbol(),NULL,"Open Graphics4Exp",BUY_Area,BUY_Target_1,SELL_Area,SELL_Target_1,0,0);
   int ticket;
   double pivot=GlobalVariableGet("OGPivot");
   double stoploss;
   
   
   int orders_count=OrdersTotal(),order_type,i;
   string symbol=Symbol();
   
   for(i=0;i<orders_count;i++)
   {
        if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES)&&OrderMagicNumber()==MAGIC_NUMB
           &&OrderSymbol()==symbol)
        {
            order_type=OrderType();
            if(order_type==OP_BUY)
            {
                    if(Bid-OrderOpenPrice()>(TrailingStop*Point))
                    {
                        if(OrderStopLoss()<(Bid-TrailingStop*Point))
                        {
                            OrderModify(OrderTicket(),OrderOpenPrice(),Bid-TrailingStop*Point,OrderTakeProfit(),0,Yellow);
                        }
                    }
            }
            if(order_type==OP_SELL)
            {
                    if(OrderOpenPrice()-Ask>(TrailingStop*Point))
                    {
                        if(OrderStopLoss()>(Ask+TrailingStop*Point)||(OrderStopLoss()==0))
                        {
                            OrderModify(OrderTicket(),OrderOpenPrice(),Ask+TrailingStop*Point,OrderTakeProfit(),0,Red);
                        }
                    }
            }
        }
        
   }
   
   if(DayOfYear()!=curr_day)
   {
      curr_day=DayOfYear();
      bs=false;
      ss=false;   
   }
   
   //Conditions for BuyStop
   //1. BuyStop must be 10 pips away Open Price
   //2. GMACD H4 and D1 Trend must be Green(Lime)
   
   if(!bs &&  Ask<GlobalVariableGet("OGBuyStop")-10*Point  && color_h4==Lime && color_d1==Lime)
   {
      double buy_stop=GlobalVariableGet("OGBuyStop");
      double buy_stop_tp=GlobalVariableGet("OGBuyStopTarget");
      stoploss=buy_stop-DefaultStopLoss*Point;
      
      if (TakeProfit*Point+buy_stop > buy_stop_tp) buy_stop_tp = TakeProfit*Point+buy_stop;
      /*if(Ask-pivot<=MarketInfo(Symbol(),MODE_STOPLEVEL)*Point)
         stoploss=Ask-DefaultStopLoss*Point;
      else
        stoploss=pivot;
        */
         
      //ticket=OrderSend(Symbol(),OP_BUYSTOP,Lots,buy_stop,3,stoploss,buy_stop_tp,0,MAGIC_NUMB,StrToTime("23:59"),Lime);
      //Edited because some brokers doesn't allow expirations
      ticket=OrderSend(Symbol(),OP_BUYSTOP,Lots,buy_stop,3,stoploss,buy_stop_tp,0,MAGIC_NUMB,0,Lime);
      if(ticket<=0)
         Print("Error opening BUYSTOP order : ",GetLastError());
      else
         bs=true;
   }
   
   //Conditions for SellStop
   //1. SellStop must be 10 pips away Open Price
   //2. GMACD H4 and D1 Trend must be Red
  
   if(!ss && Bid>GlobalVariableGet("OGSellStop")+10*Point  && color_h4==Red && color_d1==Red)
   {
      double sell_stop=GlobalVariableGet("OGSellStop");
      double sell_stop_tp=GlobalVariableGet("OGSellStopTarget");
      stoploss=sell_stop+DefaultStopLoss*Point;
      
      if (sell_stop-TakeProfit*Point < sell_stop_tp) sell_stop_tp = sell_stop-TakeProfit*Point;
     
     /* if(pivot-Bid<=MarketInfo(Symbol(),MODE_STOPLEVEL)*Point)
         stoploss=Bid+DefaultStopLoss*Point;
      else
         stoploss=pivot;
         */
      
      //ticket=OrderSend(Symbol(),OP_SELLSTOP,Lots,sell_stop,3,stoploss,sell_stop_tp,0,MAGIC_NUMB,StrToTime("23:59"),Red);
      //Edited because some brokers doesn't allow expirations
      ticket=OrderSend(Symbol(),OP_SELLSTOP,Lots,sell_stop,3,stoploss,sell_stop_tp,0,MAGIC_NUMB,0,Red);
      if(ticket<=0)
         Print("Error opening SELLSTOP order : ",GetLastError());
      else
         ss=true;
   }
   if(Hour()>=23&&Minute()>=50){
      CloseAllPositions();
      CloseAllPendingPositions();
      }
   return(0);
  }
//+------------------------------------------------------------------+